#!/usr/bin/env python
#-*- coding: iso-8859-15 -*-

import wx
import wx.html
from wx.lib.wordwrap import wordwrap
import os

version = "0.5"
favicon = "images/coban.ico"
logo = "images/coban.png"


############################################################################
##                                                                        ##
##   Changements version 0.5                                              ##
##                                                                        ##
##   - cration du module chauffage                                       ##
##   - ajustement de la largeur des boutons du lanceur                    ##
##   - rsolution de quelques bogues mineurs                              ##
##                                                                        ##
############################################################################


try :
    f = open('licence.txt', 'r')
    licenseText = f.read()
    f.close()
except :
    licenseText = (
        u'Ce logiciel est distribu sous licence GPL2.\n'
        u'\nLe fichier "licence.txt" qui contient la licence est manquant !'
        )


# conversion du rpertoire courant en rpertoire de travail
def changeDir():
    path = os.getcwd()
    os.chdir(path)


# Conversion des chemins en fonction de l'OS
def opj(path):
    """Convert paths to the platform-specific separator"""
    st = apply(os.path.join, tuple(path.split('/')))
    # HACK: on Linux, a leading / gets lost...
    if path.startswith('/'):
        st = '/' + st
    return st


def icone(dlg):
    icon = wx.Icon(favicon, wx.BITMAP_TYPE_ICO)
    dlg.SetIcon(icon)


class Coban(wx.App):
    """Application principale"""
    def OnInit(self):
        # cration de la fentre principale
        frame = Principale("Coban %s" % version) 
        
        # insertion de l'icone de l'application 
        icon = wx.Icon(favicon, wx.BITMAP_TYPE_ICO)
        frame.SetIcon(icon)
        
        frame.Show(True)
        self.SetTopWindow(frame)
        changeDir()
        return True






class Aide(wx.Frame):
    """Aide au format html"""
    def __init__(self, parent, title):
        wx.Frame.__init__(self, parent, -1, title, size=(800,600))
        html = wx.html.HtmlWindow(self)
        if "gtk2" in wx.PlatformInfo:
            html.SetStandardFonts()
            
        html.LoadFile("help.html")
       
    def onClose(self, event):
        self.Destroy()
        




class Principale(wx.Frame):
    """Lanceur principal des diffrents modules"""
    def __init__(self, titre):
        wx.Frame.__init__(self, None, -1, title = titre,
                      style=wx.DEFAULT_FRAME_STYLE ^(wx.RESIZE_BORDER | wx.MAXIMIZE_BOX))
        
        ############## Cration du panel #########################
        
        panel =  wx.Panel(self, -1, style = wx.TAB_TRAVERSAL
                     | wx.CLIP_CHILDREN
                     | wx.FULL_REPAINT_ON_RESIZE
                     )
        
        ############## cration du sizer principal ###############
        
        self.gbs = wx.GridBagSizer(hgap=5, vgap=5)
        
        ############## Cration de statusbar #####################
        
        self.CreateStatusBar()
        self.SetStatusText("Consultez l'aide pour plus d'infos...")
        
        #################CRATION DES MENUS #######################
        
        barreMenu = wx.MenuBar()
        
        # Menu des modules
        
        self.menuModule = wx.Menu()
        # module Section
        self.menuModuleSection = self.menuModule.Append(wx.ID_ANY, u"Sections de cble", 
                                              u"Calculs de section de cble")
        self.Bind(wx.EVT_MENU, self.onSection, self.menuModuleSection)
        # module conversion
        self.menuModuleConversion = self.menuModule.Append(wx.ID_ANY, u"Conversions W/A/CV/HP", 
                                                 u"Conversions Watts / Ampres / Chevaux / Horse Power")
        self.Bind(wx.EVT_MENU, self.onConversion, self.menuModuleConversion)
        # module AWG
        self.menuModuleConvAwg = self.menuModule.Append(wx.ID_ANY, u"Conversion AWG", 
                                                 u"Conversion de l'AWG vers mm2")
        self.Bind(wx.EVT_MENU, self.onConvAwg, self.menuModuleConvAwg)
        self.menuModule.AppendSeparator()
        
        # module Vido
        self.menuModuleVideo = self.menuModule.Append(wx.ID_ANY, u"Calculs de champs de vision",
                                                      u"Calculs de champs de vision en fonction de focales et de distances")
        self.Bind(wx.EVT_MENU, self.onVideo, self.menuModuleVideo)
        self.menuModule.AppendSeparator()
        
        self.menuModuleChauffage = self.menuModule.Append(wx.ID_ANY, u'Calculs de puissances calorifiques',
                                                          u'Calculer la puissance ncessaire pour chauffer une pice')
        self.Bind(wx.EVT_MENU, self.onChauffage, self.menuModuleChauffage)
        self.menuModule.AppendSeparator()
        
        self.menuModuleQuitter = self.menuModule.Append(wx.ID_EXIT, "Quitter", "Quitter l'application...")
        self.Bind(wx.EVT_MENU, self.onQuitter, self.menuModuleQuitter)
        
        # Menu Aide 
        menuAide = wx.Menu()
        menuAideAide = menuAide.Append(wx.ID_HELP,'Aide', u"Aide sur le logiciel")
        self.Bind(wx.EVT_MENU, self.onAide, menuAideAide)
        menuAideApropos = menuAide.Append(wx.ID_ABOUT,'A propos...', u"A propos de ce logiciel...")
        self.Bind(wx.EVT_MENU, self.onApropos, menuAideApropos)
                
        barreMenu.Append(self.menuModule, u"&Modules") 
        barreMenu.Append(menuAide, "&Aide")
        
        self.SetMenuBar(barreMenu)
        
        ############## Cration de la Toobar ############
        
        #outils = wx.ToolBar(self, -1, style = wx.TB_HORIZONTAL | wx.NO_BORDER)
        #outils.AddSimpleTool(wx.ID_ANY, 
                             #wx.Bitmap("images/conv.png", wx.BITMAP_TYPE_PNG), 
                             #shortHelpString = "Conversions", 
                             #longHelpString = "Ouvrir le module de conversions")
        #outils.AddSeparator()
        #outils.AddSimpleTool(wx.ID_EXIT,
                             #wx.Bitmap("images/exit.png", wx.BITMAP_TYPE_PNG),
                             #shortHelpString = "Quitter",
                             #longHelpString = "Quitter l'application")
        #outils.Realize()
        #self.SetToolBar(outils)
        
        ############## Cration des widgets ######################
        colSize = (240,30)
        
        # titres 
        font = wx.Font(12, wx.SWISS, wx.NORMAL, wx.BOLD)
        titreElec = wx.StaticText(panel, -1, u"LECTRICIT", size=colSize, style=wx.ALIGN_CENTRE)
        titreElec.SetFont(font)
        titreSonoVideo = wx.StaticText(panel, -1, u"SONO - VIDO",size=colSize, style=wx.ALIGN_CENTER)
        titreSonoVideo.SetFont(font)
        titreClimatic = wx.StaticText(panel, -1, u"CLIMATIC",size=colSize, style=wx.ALIGN_CENTRE)
        titreClimatic.SetFont(font)
        
        # bouton Sections
        self.btnSect = wx.Button(panel, -1, u"Calculer des sections de cble", size=colSize)
        self.btnSect.SetToolTipString(u"calcul des sections de cble en fonction de l'intensit et le la puissance")
        self.Bind(wx.EVT_BUTTON, self.onSection, self.btnSect)
        
        # bouton Conversions
        self.btnConv = wx.Button(panel, -1, "Convertir des valeurs W / A / CV / HP", size=colSize)
        self.btnConv.SetToolTipString(u"Convertir Watts en Ampres, CV et HP...")
        self.Bind(wx.EVT_BUTTON, self.onConversion, self.btnConv)
        
        # bouton Conversion AWG
        self.btnConvAwg = wx.Button(panel, -1, "Convertir des AWG", size=colSize)
        self.btnConvAwg.SetToolTipString("Convertir des AWG en mm")
        self.Bind(wx.EVT_BUTTON, self.onConvAwg, self.btnConvAwg)
        
        # bouton Vido
        self.btnVideo = wx.Button(panel, -1, "Calculer des champs de vision", size=colSize)
        self.btnVideo.SetToolTipString(u"Calculs de champs de vision en fonction de focales et de distances")
        self.Bind(wx.EVT_BUTTON, self.onVideo, self.btnVideo)
        
        # bouton chauffage
        self.btnChauff = wx.Button(panel, -1, "Calculer des puissances calorifiques", size=colSize)
        self.btnChauff.SetToolTipString(u"Calculs de puissances calorifiques d'une pice")
        self.Bind(wx.EVT_BUTTON, self.onChauffage, self.btnChauff)
        
        # bouton Quitter
        self.btnQuit = wx.Button(panel, -1, "Quitter")
        self.btnQuit.SetToolTipString("Quitter l'application...")
        self.Bind(wx.EVT_BUTTON, self.onQuitter, self.btnQuit)
        
        # logo de l'application
        #pos = 100
        #img = wx.Image(opj(logo), wx.BITMAP_TYPE_PNG).ConvertToBitmap()
        #pos = pos + img.GetHeight() + 10
        #self.logo = wx.StaticBitmap(panel, -1, img, (10, pos), (img.GetWidth(), img.GetHeight()))
        
        ############### Ajout des wigets au sizer ####################
        
        self.gbs.Add(titreElec, (0,1))
        self.gbs.Add(titreSonoVideo, (0,2))
        self.gbs.Add(titreClimatic, (4,1))
        self.gbs.Add(self.btnSect, (1,1))
        self.gbs.Add(self.btnConv, (2,1))
        self.gbs.Add(self.btnConvAwg, (3,1))
        self.gbs.Add(self.btnVideo, (1,2))
        self.gbs.Add(self.btnChauff, (5,1))
        self.gbs.Add(self.btnQuit, (6,3))
        #self.gbs.Add(self.logo, (8,0))        
        
        panel.SetSizerAndFit(self.gbs)
        self.SetClientSize(panel.GetSize())
        
        self.Centre() # centre la fentre  l'ouverture sur l'cran
        

    def onSection(self, evt):
        import section
        self.dlg = section.ModuleSection(self)
        self.btnSect.Enable(False)
        self.menuModuleSection.Enable(False)
        icone(self.dlg)
        self.dlg.Show(True)
        

    def onConversion(self, evt):
        import conversion
        self.dlg = conversion.ModuleConv(self)
        self.btnConv.Enable(False)
        self.menuModuleConversion.Enable(False)
        icone(self.dlg)
        self.dlg.Show(True)
        
    def onConvAwg(self, evt):
        import convawg
        self.dlg = convawg.Awg(self)
        self.btnConvAwg.Enable(False)
        self.menuModuleConvAwg.Enable(False)
        icone(self.dlg)
        self.dlg.Show(True)
        
    def onVideo(self, evt):
        import video
        self.dlg = video.Video(self)
        self.btnVideo.Enable(False)
        self.menuModuleVideo.Enable(False)
        icone(self.dlg)
        self.dlg.Show(True)
        
    def onChauffage(self, evt):
        import chauffage
        self.dlg = chauffage.Chauffage(self)
        self.btnChauff.Enable(False)
        self.menuModuleChauffage.Enable(False)
        icone(self.dlg)
        self.dlg.Show(True)

    def onQuitter(self, evt):
        """Quitter l'application"""
        self.Destroy()

    def onAide(self, evt):
        self.dlg = Aide(self, "Aide" )
        self.dlg.Show(True)
    
    def onApropos(self, evt):
        info = wx.AboutDialogInfo()
        info.Name = "Coban" 
        info.Version = "%s" % version
        info.Description = wordwrap(
            u"Coban est un petit utilitaire permettant de calculer rapidement la section d'un cble, "
            u"de raliser des conversions d'units lectriques, etc..."
            u"\n\nCe programme est un logiciel libre ; \nVous pouvez le redistribuer et/ou le modifier "
            u"au titre des clauses de la Licence Publique Gnrale GNU"
            u"; \nsoit la version 2 de la Licence, ou "
            u"une version ultrieure quelconque. \n\nCe programme est distribu dans l'espoir qu'il sera "
            u"utile, mais SANS AUCUNE GARANTIE ; \nSans mme une garantie implicite de COMMERCIABILITE ou "
            u"DE CONFORMITE A UNE UTILISATION PARTICULIERE. \nVoir la Licence Publique Gnrale GNU pour "
            u"plus de dtails \n(fichier \"licence.txt\")"
            u"\n\nPour tout contact, visiter le site ci-dessous",
            350, wx.ClientDC(self))
        info.WebSite = ("http://www.coban.tuxfamily.org")
        info.Developers = [ u"Stphan GURIN | setthe@tuxfamily.org"]
        info.Licence = licenseText
        wx.AboutBox(info)    

if __name__ == "__main__":
    app = Coban()
    app.MainLoop()
